#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linux/videodev.h>

#include "ccvt.h"

unsigned char * convert_to_rgb(unsigned char *in, int width, int height, int palette)
{
	int loop;
	unsigned char *out = (unsigned char *)malloc(width * height * 3);
	if (!out)
	{
		fprintf(stderr, "Cannot allocate memory!\n");
		exit(1);
	}

	if (palette == VIDEO_PALETTE_GREY)
	{
		int index = 0;

		for(loop=0; loop<(width*height); loop++)
		{
			out[index++] = in[loop];
			out[index++] = in[loop];
			out[index++] = in[loop];
		}
	}
	else if (palette == VIDEO_PALETTE_RGB24)
	{
		memcpy(out, in, width * height * 3);
	}
	else if (palette == VIDEO_PALETTE_YUV420P)
	{
		ccvt_420p_rgb24(width, height, in, out);
	}
	else
	{
		fprintf(stderr, "Palettetype %d not supported!\n", palette);
		exit(1);
	}

	return out;
}
